use strict;
use warnings;
use Test::More;

use_ok('Bread::Board::LifeCycle::TouchFile');

use Bread::Board;
use File::Temp;

my $tmp = File::Temp->new;

my $c = container 'TestLifeCycleTouchFile' => as {
    service touch_file => $tmp->filename;
    service random_number => (
        lifecycle => 'TouchFile',
        dependencies => {
            touch_file => depends_on('touch_file'),
        },
        block => sub {
            rand;
        },
    );
};

my @ret;
my $get = sub { push @ret, $c->resolve( service => 'random_number' ) };

&$get;
&$get;
is( $ret[-1], $ret[-2] );
&$get;
is( $ret[-1], $ret[-2] );
utime 0, time+1, $tmp->filename;
&$get;
isnt( $ret[-1], $ret[-2] );
&$get;
is( $ret[-1], $ret[-2] );
utime 0, time+2, $tmp->filename;
&$get;
isnt( $ret[-1], $ret[-2] );

done_testing;
